@echo off

Title Admin Check
Color 1F
cd "%systemroot%\system32"
call :IsAdmin

TITLE Administrative Tools - Context Menu Auto Translate v1.5
echo CT Menu...

for /f "tokens=4-5 delims=. " %%i in ('ver') do set "TestWinVer=%%i.%%j"

REM W10/S2016/S2019
IF "%TestWinVer%"=="10.0" SET "LLFlag1=1" & SET "Only10=1" & SET "Is810=1"

REM W8.1/S2012R2
IF "%TestWinVer%"=="6.3" SET "LLFlag1=1" & SET "Is810=1"

REM W8.0/S2012
IF "%TestWinVer%"=="6.2" SET "LLFlag1=1" & SET "Is810=1"

REM W7/S2008R2
IF "%TestWinVer%"=="6.1" SET "LLFlag1=0" & SET "Is810=0"

REM Vista/S2008
IF "%TestWinVer%"=="6.0" echo. & echo Vista Kernels not supported. & GOTO :finished


REM In case the checks have removed certain invalid chars results in a nul result.
IF NOT DEFINED CMSMT SET "CMSMT=@%SystemRoot%\system32\shell32.dll,-22982"
IF NOT DEFINED CMASP SET "CMASP=@%SystemRoot%\system32\sysdm.cpl,-101"
IF NOT DEFINED CMCPAN SET "CMCPAN=@%SystemRoot%\system32\shell32.dll,-4161"
rem IF NOT DEFINED CMDEVM SET "CMDEVM=@%SystemRoot%\system32\systemcpl.dll,-100"
IF NOT DEFINED CMDEVM SET "CMDEVM=@%SystemRoot%\System32\devmgr.dll,-4"
IF NOT DEFINED CMEV SET "CMEV=@%SystemRoot%\system32\shell32.dll,-22029"
IF NOT DEFINED CMRED SET "CMRED=@%SystemRoot%\regedit.exe,-16"
IF NOT DEFINED CMSECC SET "CMSECC=@%SystemRoot%\system32\wscui.cpl,-2001"
IF NOT DEFINED CMTSKS SET "CMTSKS=@%SystemRoot%\system32\shell32.dll,-22058"
IF /I "%Only10%"=="1" IF NOT DEFINED CMWSET SET "CMWSET=@%SystemRoot%\system32\shell32.dll,-30618"
IF NOT DEFINED CMWUPD SET "CMWUPD=@%SystemRoot%\system32\shell32.dll,-22068"

IF NOT DEFINED CMPRGT SET "CMPRGT=@%systemroot%\system32\appwiz.cpl,-159"

rem 24106 w7
rem IF NOT DEFINED CMPRGT (
rem IF /I "%LLFlag1%"=="0" SET "CMPRGT=@%SystemRoot%\system32\shell32.dll,-24106"
rem IF /I "%LLFlag1%"=="1" SET "CMPRGT=@%SystemRoot%\system32\shell32.dll,-33248"
rem SET "DummyMS=")

SET "AdvSysCMx=AdvSysPrp;" & SET "TPMYCM=1"
SET "DevMCMx=DevMan;" & SET "TPMYCM=1"
SET "EnvtVwrCMx=EventV;" & SET "TPMYCM=1"
SET "RegEditCMx=RegEd;" & SET "TPMYCM=1"
SET "MSCFCMx=MSCfg;" & SET "TPMYCM=1"
IF /I "%Only10%"=="1" SET "PCSetCMx=PCSet;" & SET "TPMYCM=1"
SET "ProgFeatCMx=ProgFeat;" & SET "TPMYCM=1"
SET "SecCtrCMx=SecCtr;" & SET "TPMYCM=1"
SET "SvcsCMx=Servcs;" & SET "TPMYCM=1"
SET "TaskSchdCMx=TaskSchd;" & SET "TPMYCM=1"
SET "CPTPCMx=ContPanl;" & SET "TPMYCM=1"
SET "WUDCMx=WUDT;" & SET "TPMYCM=1"

IF DEFINED TPMYCM SET "ToolsMenu=%AdvSysCMx%%CPTPCMx%%DevMCMx%%EnvtVwrCMx%%MSCFCMx%%ProgFeatCMx%%RegEditCMx%%SecCtrCMx%%SvcsCMx%%TaskSchdCMx%%PCSetCMx%%WUDCMx%"
IF DEFINED ToolsMenu SET "ToolsMenu=%ToolsMenu:~0,-1%"
SET "TMSetIcon=%%SystemRoot%%\system32\imageres.dll,104"


 Reg add "HKCR\CLSID\{20D04FE0-3AEA-1069-A2D8-08002B30309D}\shell\SystemTools" /v "MUIVerb" /t REG_SZ /d "%CMSMT%" /f >nul 2>&1
 Reg add "HKCR\CLSID\{20D04FE0-3AEA-1069-A2D8-08002B30309D}\shell\SystemTools" /v "SubCommands" /t REG_SZ /d "%ToolsMenu%" /f >nul 2>&1
 Reg add "HKCR\CLSID\{20D04FE0-3AEA-1069-A2D8-08002B30309D}\shell\SystemTools" /v "Icon" /t REG_EXPAND_SZ /d "%TMSetIcon%" /f >nul 2>&1

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\AdvSysPrp" /ve /t REG_SZ /d "%CMASP%" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\AdvSysPrp" /v "Icon" /t REG_EXPAND_SZ /d "sysdm.cpl" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\AdvSysPrp\command" /ve /t REG_EXPAND_SZ /d "control sysdm.cpl" /f >nul 2>&1

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\DevMan" /ve /t REG_SZ /d "%CMDEVM%" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\DevMan" /v "SuppressionPolicy" /t REG_DWORD /d "1073741884" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\DevMan" /v "Icon" /t REG_EXPAND_SZ /d "imageres.dll,-114" /f >NUL 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\DevMan\command" /ve /t REG_EXPAND_SZ /d "%%windir%%\system32\mmc.exe /s %%SystemRoot%%\system32\devmgmt.msc /s" /f >nul 2>&1

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\RegEd" /ve /t REG_SZ /d "%CMRED%" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\RegEd" /v "Icon" /t REG_EXPAND_SZ /d "regedit.exe" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\RegEd\command" /ve /t REG_SZ /d "regedit.exe" /f >nul 2>&1

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\MSCfg" /ve /t REG_SZ /d "MSConfig" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\MSCfg" /v "Icon" /t REG_EXPAND_SZ /d "msconfig.exe" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\MSCfg\command" /ve /t REG_SZ /d "msconfig.exe" /f >nul 2>&1

	IF /I "%Only10%"=="1" (
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\PCSet" /ve /t REG_SZ /d "%CMWSET%" /f >nul 2>&1
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\PCSet" /v "SettingsURI" /t REG_SZ /d "ms-settings:home" /f >nul 2>&1
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\PCSet" /v "Icon" /t REG_EXPAND_SZ /d "%%SystemRoot%%\system32\shell32.dll,-326" /f >nul 2>&1
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\PCSet\command" /v "DelegateExecute" /t REG_SZ /d "{556FF0D6-A1EE-49E5-9FA4-90AE116AD744}" /f >nul 2>&1
	)

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\ProgFeat" /ve /t REG_SZ /d "%CMPRGT%" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\ProgFeat" /v "Icon" /t REG_EXPAND_SZ /d "appwiz.cpl" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\ProgFeat\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\system32\control.exe appwiz.cpl" /f >nul 2>&1

 rem Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\Servcs" /ve /t REG_EXPAND_SZ /d "Services" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\Servcs" /ve /t REG_EXPAND_SZ /d "@%SystemRoot%\system32\shell32.dll,-22059" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\Servcs" /v "SuppressionPolicy" /t REG_DWORD /d "1073741884" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\Servcs" /v "Icon" /t REG_EXPAND_SZ /d "filemgmt.dll" /f >NUL 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\Servcs\command" /ve /t REG_EXPAND_SZ /d "%%windir%%\system32\mmc.exe /s %%SystemRoot%%\system32\services.msc /s" /f >nul 2>&1

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\ContPanl" /ve /t REG_EXPAND_SZ /d "%CMCPAN%" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\ContPanl" /v "Icon" /t REG_EXPAND_SZ /d "imageres.dll,-27" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\ContPanl\command" /ve /t REG_SZ /d "rundll32.exe shell32.dll,Control_RunDLL" /f >nul 2>&1

	IF /I "%Only10%"=="1" (
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\WUDT" /ve /t REG_EXPAND_SZ /d "%CMWUPD%" /f >nul 2>&1
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\WUDT" /v "SettingsURI" /t REG_SZ /d "ms-settings:windowsupdate" /f >nul 2>&1
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\WUDT" /v "Icon" /t REG_EXPAND_SZ /d "shell32.dll,46" /f >nul 2>&1
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\WUDT\command" /v "DelegateExecute" /t REG_SZ /d "{556FF0D6-A1EE-49E5-9FA4-90AE116AD744}" /f >nul 2>&1
	)

	IF /I "%Is810%"=="0" (
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\WUDT" /ve /t REG_EXPAND_SZ /d "%CMWUPD%" /f >nul 2>&1
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\WUDT" /v "Icon" /t REG_EXPAND_SZ /d "wucltux.dll" /f >nul 2>&1
	Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\WUDT\command" /ve /t REG_SZ /d "wuapp.exe" /f >nul 2>&1
	)

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\EventV" /ve /t REG_SZ /d "%CMEV%" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\EventV" /v "icon" /t REG_SZ /d "eventvwr.exe" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\EventV\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\system32\mmc.exe /s %%SystemRoot%%\system32\eventvwr.msc" /f >nul 2>&1

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\SecCtr" /ve /t REG_SZ /d "%CMSECC%" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\SecCtr" /v "icon" /t REG_SZ /d "wscui.cpl" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\SecCtr\command" /ve /t REG_SZ /d "control wscui.cpl" /f >nul 2>&1

 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\TaskSchd" /ve /t REG_SZ /d "%CMTSKS%" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\TaskSchd" /v "icon" /t REG_SZ /d "miguiresource.dll,1" /f >nul 2>&1
 Reg add "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\CommandStore\shell\TaskSchd\command" /ve /t REG_SZ /d "Control schedtasks" /f >nul 2>&1

echo Done.

:finished
timeout /T 2 >nul
exit

:IsAdmin
REG query "HKU\S-1-5-19\Environment" >NUL 2>&1
If Not %ERRORLEVEL% EQU 0 (
 Cls
 Echo You must have administrator rights to continue ... 
 Pause
 Exit
)

Cls
goto:eof

